<template>
  <div class="menu">
    <wp-dropdown v-model="rawVal" :items="$props.items" class="wp--flex-1"
      :modifiers="['no_cancel', 'small', 'primary', 'fira_sans']"/>
    <div class="menu-actions">
      <div class="action action--create" v-if="$props.value.create"
        @click="$emit('create')">
        <font-awesome-icon icon="plus"/>
      </div>
      <div class="action action--edit" v-if="$props.value.edit"
        @click="$emit('edit')">
        <font-awesome-icon icon="pen" size="sm"/>
      </div>
      <div class="action action--delete" v-if="$props.value.delete"
        @click="$emit('delete')">
        <font-awesome-icon icon="trash" size="sm"/>
      </div>
    </div>
  </div>
</template>

<script>
import WpDropdown from '@/components/input/WpDropdown.vue';

export default {
  name: 'CardMenu',
  components: {
    WpDropdown,
  },
  inject: ['switchCreating', 'switchEditing', 'switchDeleting'],
  props: {
    value: {
      required: true,
      type: Object,
    },
    items: {
      type: Array,
      default: () => [],
    },
  },
  computed: {
    rawVal: {
      set(change) {
        this.$emit('input', this.items.find(item => item.prop === change));
      },
      get() {
        return this.$props.value.prop;
      },
    },
  },
};
</script>

<style lang="scss" scoped>
.menu {
  box-sizing: content-box;
  padding-left: 20px;
  height: 30px;
  display: flex;
  justify-content: flex-start;
  align-items: center;
  border-bottom: 2px solid $neutralLightest;

  &-actions {
    display: flex;
    justify-content: flex-start;
    align-items: center;

    .action {
      box-sizing: content-box;
      height: 30px;
      width: 30px;
      display: flex;
      justify-content: center;
      align-items: center;
      color: #fff;
      border-left: 2px solid $neutralLightest;
      transition: color         ease-in-out .2s,
                  background    ease-in-out .2s;

      &:hover {
        cursor: pointer;
      }

      &--create, &--edit {
        color: $primary;
        background: $surface;

        &:hover {
          color: $surface;
          background: $primary;
        }

      }

      &--delete {
        color: $secondary;
        background: $surface;

        &:hover {
          color: $surface;
          background: $secondary;
        }

      }

    }

  }

}
</style>
